/*  -*- Mode: C -*- 
 * This file is part of xui
 * 
 * lang.c -- 
 * 
 * $Id$
 * Author          : NBC02365@niftyserve.or.jp
 * Created On      : Thu Jan 25 22:51:47 1996
 * Last Modified By: NBC02365@niftyserve.or.jp
 * Last Modified On: Thu Jan 25 22:51:53 1996
 * 
 * Copyright (C) 1995,1996 Todo Software All rights reserved.
 */

#include "xnet.h"

#define xconfig(but, text, font) \
   if (but) {\
	       widget_configure(but, resource_text, text);\
	       widget_configure(but, resource_textfont, font);\
   }

static void
lang_english ()
{
  xconfig (config_button, "config", TIMESI);
  xconfig (flush_button, "flush", TIMESI);
  xconfig (visible_button, "visible", TIMESI);
  xconfig (speed_button, "speed", TIMESI);
  xconfig (autoplay_button, "autoplay", TIMESI);
  xconfig (auto_after_reach_button, "auto(R)", TIMESI);
  xconfig (auto_button, "run auto", TIMESI);
  xconfig (restart_button, "restart", TIMESI);
  xconfig (help_button, "help", TIMESI);
  xconfig (about_button, "about", TIMESI);
  xconfig (quit_button, "quit", TIMESI);
  xconfig (rule_button, "rule", TIMESI);

  xconfig (rankbutton, "rank", TIMESIB);
  xconfig (testpaibutton, "pai test", TIMESIB);
  xconfig (classbutton, "class", TIMESIB);
  xconfig (totalbutton, "info", TIMESIB);
  xconfig (bdcolorbutton, "color", TIMESIB);
  xconfig (configbutton, "config", TIMESIB);

  xconfig (configsavebutton, "set/save", TIMESIB);
  xconfig (configbyebutton, "cancel", TIMESIB);

  xconfig (pointokbutton, "ok", TIMESIB);
  xconfig (gameendokbutton, "ok", TIMESIB);
  xconfig (rankokbutton, "ok", TIMESIB);
  xconfig (playinfookbutton, "ok", TIMESIB);
  xconfig (aboutokbutton, "ok", TIMESIB);

  xconfig (configbyebutton, "cancel", TIMESIB);

  xconfig (quicklogbutton, "quicklog", TIMESIB);

  xconfig (rankmoneybutton, "money", TIMESIB);
  xconfig (rankpointbutton, "point", TIMESIB);
  xconfig (rankfuributton, "furi", TIMESIB);
}

static void
lang_jp ()
{
#ifndef ENGLISH
  xconfig (config_button, "", TINYJP);
  xconfig (flush_button, "ľ", TINYJP);
  xconfig (visible_button, "ա", TINYJP);
  xconfig (speed_button, "speed", TINYJP);
  xconfig (autoplay_button, "ư", TINYJP);
  xconfig (auto_after_reach_button, "ư(R)", TINYJP);
  xconfig (auto_button, "", TINYJP);
  xconfig (restart_button, "³", TINYJP);
  xconfig (help_button, "إ", TINYJP);
  xconfig (about_button, "Ф", TINYJP);
  xconfig (quit_button, "λ", TINYJP);
  xconfig (rule_button, "롼", TINYJP);

  xconfig (rankbutton, "", MEDIUMJP);
  xconfig (testpaibutton, "ѥ", MEDIUMJP);
  xconfig (classbutton, "ʰ", MEDIUMJP);
  xconfig (totalbutton, "", MEDIUMJP);
  xconfig (bdcolorbutton, "פο", MEDIUMJP);
  xconfig (configbutton, "", MEDIUMJP);

  xconfig (configsavebutton, "/¸", MEDIUMJP);
  xconfig (configbyebutton, "λ", MEDIUMJP);

  xconfig (pointokbutton, "λ", MEDIUMJP);
  xconfig (gameendokbutton, "λ", MEDIUMJP);
  xconfig (rankokbutton, "λ", MEDIUMJP);
  xconfig (playinfookbutton, "λ", MEDIUMJP);
  xconfig (aboutokbutton, "λ", MEDIUMJP);

  xconfig (quicklogbutton, "", MEDIUMJP);

  xconfig (rankmoneybutton, "", MEDIUMJP);
  xconfig (rankpointbutton, "ݥ", MEDIUMJP);
  xconfig (rankfuributton, "", MEDIUMJP);

#endif
}


void 
lang_set ()
{
  if (flag_original == 1)
    {
      lang_english ();
    }
  else
    {
      lang_jp ();
    }
}
